<template>
  <div>
    <SidebarRegister />
    <div class="container-register">
      <div class="icon-step">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          width="26"
          height="26"
          fill="currentColor"
          class="bi bi-person-workspace"
          viewBox="0 0 16 16"
        >
          <path
            d="M4 16s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1H4Zm4-5.95a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Z"
          />
          <path
            d="M2 1a2 2 0 0 0-2 2v9.5A1.5 1.5 0 0 0 1.5 14h.653a5.373 5.373 0 0 1 1.066-2H1V3a1 1 0 0 1 1-1h12a1 1 0 0 1 1 1v9h-2.219c.554.654.89 1.373 1.066 2h.653a1.5 1.5 0 0 0 1.5-1.5V3a2 2 0 0 0-2-2H2Z"
          />
        </svg>
      </div>
      <h3 class="mt-4 fw-bold">Informasi Pekerjaan</h3>
      <p class="subtitle">Tinjau kembali data Anda.</p>
      <div class="accordion mt-4" id="accordionExample">
        <div class="accordion-item">
          <h2 class="accordion-header" id="headingOne">
            <button
              class="accordion-button"
              type="button"
              data-bs-toggle="collapse"
              data-bs-target="#collapseOne"
              aria-expanded="true"
              aria-controls="collapseOne"
            >
              Profile Pekerja
            </button>
          </h2>
          <div
            id="collapseOne"
            class="accordion-collapse collapse show"
            aria-labelledby="headingOne"
            data-bs-parent="#accordionExample"
          >
            <div class="accordion-body">
              <div class="row">
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="nik"
                      :value="localVerifikasi.nik"
                      readonly
                    />
                    <label for="nik">Nomor Induk Kependudukan</label>
                  </div>

                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="tanggalLahir"
                      :value="localProfile.dob"
                      readonly
                    />
                    <label for="tanggalLahir">Tanggal Lahir</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="nomorHP"
                      :value="localProfile.phoneNumber"
                      readonly
                    />
                    <label for="nomorHP">Nomor Handphone</label>
                  </div>
                </div>
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="namaLengkap"
                      :value="localProfile.name"
                      readonly
                    />
                    <label for="namaLengkap">Nama Lengkap</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="jenisKelamin"
                      :value="localProfile.gender"
                      readonly
                    />
                    <label for="jenisKelamin">Jenis Kelamin</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="email"
                      :value="localProfile.email"
                      readonly
                    />
                    <label for="email">Email</label>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="accordion-item">
          <h2 class="accordion-header" id="headingTwo">
            <button
              class="accordion-button collapsed"
              type="button"
              data-bs-toggle="collapse"
              data-bs-target="#collapseTwo"
              aria-expanded="false"
              aria-controls="collapseTwo"
            >
              Informasi Pekerjaan
            </button>
          </h2>
          <div
            id="collapseTwo"
            class="accordion-collapse collapse"
            aria-labelledby="headingTwo"
            data-bs-parent="#accordionExample"
          >
            <div class="accordion-body">
              <div class="row">
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="jenisPekerjaan"
                      :value="jobTypeName"
                      readonly
                    />
                    <label for="jenisPekerjaan">Jenis Pekerjaan</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="provinsi"
                      :value="provinceName"
                      readonly
                    />
                    <label for="provinsi">Provinsi</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="noTelepon"
                      :value="localJob.numberPhone"
                      readonly
                    />
                    <label for="noTelepon">No. Telepon</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="penghasilan"
                      :value="localJob.avrIncomeMonthly"
                      readonly
                    />
                    <label for="penghasilan">Penghasilan Per Bulan</label>
                  </div>
                </div>
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="pekerjaan"
                      :value="localJob.nameJob"
                      readonly
                    />
                    <label for="pekerjaan">Pekerjaan</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="wilayah"
                      :value="regionName"
                      readonly
                    />
                    <label for="wilayah">Wilayah</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="email"
                      :value="localJob.emailJob"
                      readonly
                    />
                    <label for="email">Email</label>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="accordion-item">
          <h2 class="accordion-header" id="headingThree">
            <button
              class="accordion-button collapsed"
              type="button"
              data-bs-toggle="collapse"
              data-bs-target="#collapseThree"
              aria-expanded="false"
              aria-controls="collapseThree"
            >
              Informasi Program
            </button>
          </h2>
          <div
            id="collapseThree"
            class="accordion-collapse collapse"
            aria-labelledby="headingThree"
            data-bs-parent="#accordionExample"
          >
            <div class="accordion-body">
              <div class="row">
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="kantorCabang"
                      :value="branchName"
                      readonly
                    />
                    <label for="kantorCabang">Kantor Cabang</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="periodePembayaran"
                      :value="paymentPeriodName + ' bulan'"
                      readonly
                    />
                    <label for="periodePembayaran">Periode Pembayaran</label>
                  </div>
                </div>
                <div class="col-6">
                  <div class="form-floating mb-3">
                    <input
                      type="text"
                      class="form-control-plaintext"
                      id="program"
                      :value="programName"
                      readonly
                    />
                    <label for="program">Program</label>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="d-flex my-4 justify-content-end gap-2">
        <button type="button" class="btn btn-secondary" @click="back">
          Kembali
        </button>
        <button type="submit" class="btn btn-primary" @click="save">
          Proses Pembayaran
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import SidebarRegister from "@/components/SidebarRegister.vue";
import axios from "axios";

export default {
  name: "RegisterStep33View",
  components: {
    SidebarRegister,
  },
  data() {
    return {
      job: {},
      participant: {},
      payloadJob: {},
      payloadParticipant: {},
      jobResponse: {},
      participantResponse: {},

      localProgram: {},
      localVerifikasi: {},
      localProfile: {},
      localJob: {},
    };
  },
  computed: {
    jobTypeName() {
      return (this.localJob.idJobType ?? "").split("-")[1];
    },
    provinceName() {
      return (this.localJob.idProvince ?? "").split("-")[1];
    },
    regionName() {
      return (this.localJob.idRegion ?? "").split("-")[1];
    },
    branchName() {
      let result = "";
      if(this.localProgram) {
        result = (this.localProgram.idBranch ?? "").split("-")[1];
      }
      return result;
    },
    programName() {
      let result = "";
      if(this.localProgram) {
        result = (this.localProgram.idProgram ?? "").split("-")[1];
      }
      return result;
    },
    paymentPeriodName() {
      let result = "";
      if(this.localProgram) {
        result = (this.localProgram.idPaymentPeriod ?? "").split("-")[1];
      }
      return result;
    },
  },
  methods: {
    setData() {},
    back() {
      this.$router.push({ path: "/register/step-3-2" });
    },
    save() {
      let jobType = (this.localJob.idJobType ?? "").split("-");
      let province = (this.localJob.idProvince ?? "").split("-");
      let region = (this.localJob.idRegion ?? "").split("-");
      let branch = (this.localProgram.idBranch ?? "").split("-");
      let program = (this.localProgram.idProgram ?? "").split("-");
      let paymentPeriod = (this.localProgram.idPaymentPeriod ?? "").split("-");
      let totalJKK =
        (1 / 100) *
        parseInt(this.localJob.avrIncomeMonthly) *
        parseInt(paymentPeriod[1]);

      let totalJHT =
        (2 / 100) *
        parseInt(this.localJob.avrIncomeMonthly) *
        parseInt(paymentPeriod[1]);

      let totalJKM = 6800 * parseInt(paymentPeriod[1]);

      this.payloadJob = {
        idJobType: jobType[0],
        nameJob: this.localJob.nameJob,
        addressJob: province[0] + " - " + region[0],
        emailJob: this.localJob.emailJob,
        phoneJob: this.localJob.numberPhone,
        avrIncomeMonthly: this.localJob.avrIncomeMonthly,
      };

      this.payloadParticipant = {
        nik: this.localVerifikasi.nik,
        name: this.localProfile.name,
        dob: this.localProfile.dob,
        gender: this.localProfile.gender,
        address: this.localProfile.address,
        phoneNumber: this.localProfile.phoneNumber,
        email: this.localProfile.email,
        idJob: "",
        idBranch: branch[0],
        idProgram: program[0],
        idPaymentPeriod: paymentPeriod[0],
        totalIuranJkk: totalJKK,
        totalIuranJht: program[0] === "2" ? totalJHT : 0,
        totalIuranJkm: totalJKM,
        totalBayar: totalJKK + totalJHT + totalJKM,
      };
      localStorage.removeItem('program');
      localStorage.removeItem('job');
      localStorage.removeItem('profile');
      localStorage.removeItem('verifikasi');
      this.createJob();
    },
    createJob() {
      axios
        .post("http://localhost:3000/job/tambah", this.payloadJob)
        .then((response) => {
          this.jobResponse = response.data.data;
          this.createParticipant(response.data.data.insertId);
        })
        .catch((error) => {
          console.log(error);
        });
    },
    createParticipant(idJob) {
      this.payloadParticipant.idJob = idJob;
      axios
        .post(
          "http://localhost:3000/participant/tambah",
          this.payloadParticipant
        )
        .then((response) => {
          this.participantResponse = response.data.data;
          this.$router.push({
            path: "/register/step-4",
            query: { idParticipant: response.data.data.insertId },
          });
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
  mounted() {
    this.localProgram = JSON.parse(localStorage.getItem("program")) || null;
    if (!this.localProgram) {
      this.$router.push({ path: "/register/step-3-2" });
      return;
    }

    this.localVerifikasi =
      JSON.parse(localStorage.getItem("verifikasi")) || null;
    this.localProfile = JSON.parse(localStorage.getItem("profile")) || null;
    this.localJob = JSON.parse(localStorage.getItem("job")) || null;
  },
};
</script>

<style>
</style>